VOCABA ; *******************************************************
 ; USR-CALLABLE ROUTINE FOR USE WITH BASIC PROGRAMS TO
 ; PROVIDE SPEECH OUTPUT.  TWO VALUES TRANSFERRED TO HL.
 ; *******************************************************
 ;
 	ORG	5000H		; SOMEWHERE IN MEMORY
 ; >>>> POKE 16526,0 : POKE 16527,80 : A = USR(START)
 START1	DI			; USE IT WITHOUT BOTHER
 	CALL	0A7FH		; TRANSFER START TO HL
 	LD	(4FFEH),HL	; PLACE INTO MEMORY
 	RET			; BACK FOR NEXT VARIABLE
 ; >>>> POKE 16526,8 : A=USR(CONCLUDE)
 START2	CALL	0A7FH		; TRANSFER END TO HL
 	LD	(4FFCH),HL	; PLACE INTO MEMORY
 	LD	A,(403DH)	; PORT FF OUTPUT MASK
 	LD	C,A		; SAVE OUTPUT MASK IN C
 	LD	HL,(4FFEH)	; GET START OF MEM. BLOCK
 	LD	DE,(4FFCH)	; GET END OF MEM. BLOCK
 	PUSH	DE		; AND SAVE VALUE ON STACK
 LOOP1	LD	D,8		; NUMBER OF BITS IN BYTE
 	LD	A,(HL)		; GET VALUE FROM MEMORY
 	LD	E,A		; SAVE IT IN E REGISTER
 	XOR	A		; CLEAR ACCUMULATOR TO 0
 LOOP2	RL	E		; SEND BIT TO CARRY FLAG
 	RL	A		; AND ROTATE 'ROUND TO A
 	OR	C		; USE THE PORT FF MASK
 	OUT	(0FFH),A	; AND SEND OUT THE VALUE
 	LD	B,4		; GET SHORT DELAY VALUE
 DELAY	DJNZ	DELAY		; AND DELAY SHORT WHILE
 	XOR	A		; CLEAR ACCUM. BACK TO 0
 	DEC	D		; BITS = BITS MINUS ONE
 	JP	NZ,LOOP2	; AND BACK FOR SOME MORE
 	INC	HL		; GET NEXT BYTE FROM MEM.
 	POP	DE		; GET STACKED END VALUE
 	PUSH	DE		; SAVE IT AGAIN
 	PUSH	HL		; SAVE CURRENT HL VALUE
 	XOR	A		; CLEAR THE CARRY FLAG
 	SBC	HL,DE		; DO THE SUBTRACTION
 	POP	HL		; RESTORE THE MEM. VALUE
 	JP	M,LOOP1		; AND GO BACK FOR MORE
 	POP	DE		; CLEAR THE STACK
 	RET			; AND BACK WHEN DONE
 ;
 ;
 ; *******************************************************
 	END	START1
